- include_role:
    name: commons
    tasks_from: helpers/volume.yaml
  vars:
    vol_name: "{{ scalelite_name }}"
    vol_size: "{{ scalelite_data_capacity }}"
- include_role:
    name: commons
    tasks_from: helpers/deployment.yaml
  vars:
    cfive_cpu_limit: "{{ sshd_cpu_limit }}"
    cfive_cpu_request: "{{ sshd_cpu_request }}"
    cfive_idx: "{{ 6 if (do_backups
                         and do_exporters)
                     else (4 if (do_backups)
                             else 0) }}"
    cfive_memory_limit: "{{ sshd_memory_limit }}"
    cfive_memory_request: "{{ sshd_memory_request }}"
    cfive_tag: "{{ sshd_tag }}"
    cfour_cpu_limit: "{{ exporter_cpu_limit }}"
    cfour_cpu_request: "{{ exporter_cpu_request }}"
    cfour_idx: "{{ 5 if (do_exporters)
                     else 0 }}"
    cfour_memory_limit: "{{ exporter_memory_limit }}"
    cfour_memory_request: "{{ exporter_memory_request }}"
    cfour_tag: "{{ scaleliteexporter_tag }}"
    cone_cpu_limit: "{{ scalelite_poller_cpu_limit }}"
    cone_cpu_request: "{{ scalelite_poller_cpu_request }}"
    cone_idx: 1
    cone_memory_limit: "{{ scalelite_poller_memory_limit }}"
    cone_memory_request: "{{ scalelite_poller_memory_request }}"
    cone_tag: "{{ scalelite_tag }}"
    cpu_limit: "{{ scalelite_cpu_limit }}"
    cpu_request: "{{ scalelite_cpu_request }}"
    ctoo_cpu_limit: "{{ scalelite_importer_cpu_limit }}"
    ctoo_cpu_request: "{{ scalelite_importer_cpu_request }}"
    ctoo_idx: 2
    ctoo_memory_limit: "{{ scalelite_importer_memory_limit }}"
    ctoo_memory_request: "{{ scalelite_importer_memory_request }}"
    ctoo_tag: "{{ scalelite_tag }}"
    ctree_cpu_limit: "{{ scalelite_nginx_cpu_limit }}"
    ctree_cpu_request: "{{ scalelite_nginx_cpu_request }}"
    ctree_idx: 3
    ctree_memory_limit: "{{ scalelite_nginx_memory_limit }}"
    ctree_memory_request: "{{ scalelite_nginx_memory_request }}"
    ctree_tag: "{{ scalelite_tag }}"
    dc_data: "{{ lookup('template', 'scalelite-allinone.j2') }}"
    dc_name: "{{ scalelite_name }}"
    dc_replicas: 1
    dc_tag: "{{ scalelite_tag }}"
    exporter_idx: 4
    exporter_tag: "{{ nginxexporter_tag }}"
    memory_limit: "{{ scalelite_memory_limit }}"
    memory_request: "{{ scalelite_memory_request }}"
- include_role:
    name: commons
    tasks_from: helpers/service.yaml
  vars:
    ports:
    - 8080
    svc_name: "{{ scalelite_name }}"
- include_role:
    name: commons
    tasks_from: helpers/route.yaml
  vars:
    route_host: "scalelite.{{ root_domain }}"
    route_name: "{{ scalelite_name }}"
    svc_name: "{{ scalelite_name }}"
- include_role:
    name: commons
    tasks_from: helpers/network-policy.yaml
  vars:
    source:
    - namespace: "{{ default_namespace_match }}"
    policy_name: "public-to-{{ scalelite_name }}"
    policy_state: "{{ 'present' if (do_network_policy)
                                else 'absent' }}"
    subject: "{{ scalelite_name }}"
    to:
    - number: "8080"
- include_role:
    name: commons
    tasks_from: helpers/service.yaml
  vars:
    is_exporter: True
    ports:
    - 9113
    - 9114
    svc_name: "{{ scalelite_name }}"
    svc_state: "{{ 'present' if (do_exporters)
                             else 'absent' }}"
- include_role:
    name: commons
    tasks_from: helpers/network-policy.yaml
  vars:
    source:
    - namespace: "{{ prometheus_namespace_match }}"
    policy_name: "prometheus-to-{{ scalelite_name }}"
    policy_state: "{{ 'present' if (do_exporters
                                    and do_network_policy)
                                else 'absent' }}"
    subject: "{{ scalelite_name }}"
    to:
    - number: "9113"
    - number: "9114"
- block:
  - block:
    - name: Resolves Scalelite Pods
      async: 30
      changed_when: False
      failed_when: False
      k8s_info:
        api_version: v1
        kind: Pod
        namespace: "{{ namespace }}"
        label_selectors:
        - "name={{ scalelite_name }}"
      no_log: True
      poll: 5
      register: has_pods
    - include_role:
        name: commons
        tasks_from: helpers/restartpod.yaml
      loop: "{{ has_pods.resources }}"
      vars:
        pod_name: "{{ item.metadata.name }}"
        wait_for_apivers: "{{ deployment_apivers }}"
        wait_for_kind: "{{ deployment_kind }}"
        wait_for_objname: "{{ scalelite_name }}"
      when:
      - has_pods is defined
      - has_pods.resources is defined
      - has_pods.resources | length > 0
    when:
    - not (dc_started is changed)
    - >
        (cacfg is defined
         and cacfg is changed)
        or (slcfg is defined
            and slcfg is changed)
  - include_role:
      name: commons
      tasks_from: helpers/wait-for.yaml
    vars:
      check_with: "{{ lookup('k8s', api_version=deployment_apivers,
                             kind=deployment_kind, namespace=namespace,
                             resource_name=scalelite_name) | default('') }}"
      obj_name: "{{ scalelite_name }}"
      retries_for: 90
      wait_for: 30
    when:
    - dc_started is changed
  when:
  - dc_started is defined
